#!/usr/bin/bash

# There are three vsersion of kernel used by Anolis OS: kernel 4.18;kernel 4.19;kernel 5.10
# It will cause mismatch kernel version when you run update or upgrade kernel.
# There script is in order to keep the package version unchanged.
#
#

PARAMS=$*
COMMAND=$1

# config file dir
CONF_DIR="/etc/preserve.d/"
EXCLUDE_LIST=""
INSTALL_HANDLED=""

function yum_run {
    if [ ! -z "$EXCLUDE_LIST" ]
    then
         # --exclude the package whick need keep version
         yum $PARAMS $EXCLUDE_LIST
         # update the packages that version is spcicfied.
         yum $PARAMS $INSTALL_HANDLED
    else
            yum $PARAMS
    fi
}

function yum_load {
    echo "Some packages version should keep unchanged."

    local CONF_LIST=`ls $CONF_DIR/*`
    local INSTALL_HANDLED=""
    ASSUME_NO=" --assumeno"
    YUM_RES=`yum $PARAMS $ASSUME_NO 2> /dev/null`
    
    for conf in $CONF_LIST
    do
        echo "Loading conf file $conf"
        echo "Analyzing..."
        local ALLOWED_VERSION=`cat $conf|grep allowed_version|cut -d: -f2|sed "s/ //g"`
        local PKGS_LIST=`cat $conf|grep pkgs|cut -d: -f2`
        for pkg in $PKGS_LIST
        do
            # split packages list into two parts: need to keep version and not
            echo "$YUM_RES"|grep -q -i $pkg && EXCLUDE_LIST="$EXCLUDE_LIST --exclude $pkg" && INSTALL_HANDLED=" $INSTALL_HANDLED $pkg-$ALLOWED_VERSION"
        done
    done
}

# just effect in following situations:
if [ $COMMAND == "install" ] || [ $COMMAND == "update" ] || [ $COMMAND == "downgrade" ] || [ $COMMAND == "upgrade" ];
then
    yum_load
    yum_run
else
    yum $PARAMS
fi

